package Tabu;

import Utils.Action;

import java.util.ArrayList;
import java.util.List;

public class TabuList {
    private final int tenure;
    List<Action> list = new ArrayList<>();

    public TabuList(int tenure) {
        this.tenure = tenure;
    }

    public boolean contains(Action a) {
        for (Action b : list)
            if (a.equals(b)) return true;
        return false;
    }

    public void add(Action a) {
        list.add(a);
        if (list.size() > tenure)
            list.remove(0);
    }

    // Class behaviour test
    // Expected output: T, T, F, T, F
    public static void main(String[] args) {
        TabuList l = new TabuList(20);
        for (int i = 0; i < 20; i++) {
            l.add(new Action(i, 1));
        }
        System.out.println(l.contains(new Action(2, 1)));
        System.out.println(l.contains(new Action(1, 2)));
        System.out.println(l.contains(new Action(20, 20)));
        System.out.println(l.contains(new Action(0, 1)));
        l.add(new Action(20, 20));
        System.out.println(l.contains(new Action(0, 1)));
    }
}
