package Tabu;

import Utils.Action;

import java.util.HashMap;

public class TabuListMap {
    private final int tenure;
    private final HashMap<Action, Integer> list;

    public TabuListMap(int tenure) {
        this.tenure = tenure;
        list = new HashMap<>();
    }

    public boolean contains(Action a) {
        return list.containsKey(a);
    }

    public void add(Action a) {
        list.put(a, tenure);
        for (Action k : list.keySet()) {
            list.put(k, list.get(k)-1);
            if (list.get(k) == -1) list.remove(k);
        }
    }

    // Class behaviour test
    // Expected output: T, T, F, T, F
    public static void main(String[] args) {
        TabuList l = new TabuList(20);
        for (int i = 0; i < 20; i++) {
            l.add(new Action(i, 1));
        }
        System.out.println(l.contains(new Action(2, 1)));
        System.out.println(l.contains(new Action(1, 2)));
        System.out.println(l.contains(new Action(20, 20)));
        System.out.println(l.contains(new Action(0, 1)));
        l.add(new Action(20, 20));
        System.out.println(l.contains(new Action(0, 1)));
    }
}
