package Testing;

import VoteReveal.RevealOrder;
import VoteReveal.RevealProblem;
import VoteReveal.VRPDataReader;

public class FunctionAnalysis {
    public static void main(String[] args) {
        RevealProblem problem = VRPDataReader.readData("EurovisionFinal2019.txt");
        float[] totals = new float[6];
        float[] maxes = new float[]{Integer.MIN_VALUE, Integer.MIN_VALUE, Integer.MIN_VALUE, Integer.MIN_VALUE, Integer.MIN_VALUE, Integer.MIN_VALUE};
        RevealOrder[] best = new RevealOrder[6];
        char[] funcs = new char[]{'B','L','P','Q','T','U'};
        for (int i = 0; i < 1000000; i++) {
            assert problem != null;
            RevealOrder X = problem.getRandomSolution();
            for (int j = 0; j < funcs.length; j++) {
                float val = X.getCost(funcs[j]);
                totals[j] += val;
                if (val > maxes[j]) {
                    maxes[j] = val;
                    best[j] = X;
                }
            }
        }
        for (int k = 0; k < totals.length; k++) {
            best[k].write(funcs[k], "RandomSampling");
            totals[k] /= 1000000;
            System.out.println(funcs[k] + " " + Math.abs(totals[k]) + " " + Math.abs(maxes[k]));
        }
    }
}
