package VoteReveal;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class RevealProblem {
    public final String instanceFile;
    public final String title;
    public final String[] candidates;
    public final String[] voters;
    public final int[][] votes;

    public RevealProblem(String instanceFile, String title, String[] candidates, String[] voters, int[][] votes) {
        this.instanceFile = instanceFile;
        this.title = title;
        this.candidates = candidates;
        this.voters = voters;
        this.votes = votes;
    }

    public RevealOrder getRandomSolution() {
        // Generate random array of voter numbers
        List<Integer> order = new ArrayList<>();
        for (int i = 0; i < voters.length; i++) order.add(i);
        Collections.shuffle(order);

        // Convert to array
        int[] arrayOrder = new int[order.size()];
        for (int i = 0; i < arrayOrder.length; i++) arrayOrder[i] = order.get(i);

        // Instantiate a reveal order
        return new RevealOrder(arrayOrder, this);
    }
}
