package VoteReveal;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class VRPDataReader {
    public static RevealProblem readData(String filename) {
        try {
            File f = new File(filename);
            Scanner sc = new Scanner(f);

            // Read title
            String title = sc.nextLine();

            // Read candidates
            int numCandidates = Integer.parseInt(sc.nextLine());
            String[] candidates = new String[numCandidates];
            for (int i = 0; i < numCandidates; i++) {
                candidates[i] = sc.nextLine().strip();
            }

            // Read voters
            int numVoters = Integer.parseInt(sc.nextLine());
            String[] voters = new String[numVoters];
            for (int i = 0; i < numVoters; i++) {
                voters[i] = sc.nextLine().strip();
            }

            // Read vote info
            int[][] votes = new int[numVoters][numCandidates];
            for (int v = 0; v < numVoters; v++) {
                Scanner rowScanner = new Scanner(sc.nextLine());
                rowScanner.useDelimiter(",");
                for (int c = 0; c < numCandidates; c++) {
                    votes[v][c] = Integer.parseInt(rowScanner.next().strip());
                }
            }

            return new RevealProblem(filename, title, candidates, voters, votes);
        }
        catch (FileNotFoundException e) {
            e.printStackTrace();
            return null;
        }
    }
}
